#!/bin/ash
# /usr/local/bin/progs-default.sh, version 2 
# (avec mise en forme centrée et détection d'existence)
# But : créer un aemenu des logiciels par défaut dans
# 	PuppyLinux pour le gest. de fen. aewm, echinus ou autre.
# Dépendance : aemenu
# (c) musher0, 31 mai 2015.
#### set -xe
cd /usr/local/bin/
DeFProgs="/tmp/progs-default"

construire (){
wc -l /tmp/liste-progs > /tmp/compte-de-lignes
case ${LANG:0:2} in
	fr)Header="~ Par défaut ~";Footer="~ dans Puppy ~" ;;
	*)Header="~ By default ~";Footer=" ~ in Puppy ~" ;; esac

echo -e "menu \" $Header\" \ncmd \"~~~~~~~~~~\" \" \"" > "$DeFProgs"

for i in `cat /tmp/liste-progs`;do j="${i#*t}"
if [ "`echo $j | wc -c`" -eq "4" -o "`echo $j | wc -c`" -eq "5" ];then
	echo "cmd \"        $j\" $i" >> "$DeFProgs"
elif [ "`echo $j | wc -c`" -eq "6" -o "`echo $j | wc -c`" -lt "7" ];then
	echo "cmd \"       $j\" $i" >> "$DeFProgs"
elif [ "`echo $j | wc -c`" -eq "8" -o "`echo $j | wc -c`" -lt "9" ];then
	echo "cmd \"      $j\" $i" >> "$DeFProgs"
elif [ "`echo $j | wc -c`" -eq "10" -o "`echo $j | wc -c`" -lt "11" ];then
	echo "cmd \"     $j\" $i" >> "$DeFProgs"
elif [ "`echo $j | wc -c`" -eq "12" -o "`echo $j | wc -c`" -lt "13" ];then
	echo "cmd \"    $j\" $i" >> "$DeFProgs"
else
	echo "cmd \"  $j\" $i" >> "$DeFProgs"
fi;done # création du menu avec entrées centrées

echo -e "cmd \"~~~~~~~~~~~\" \" \" \ncmd \" $Footer\" \" \" \nend \n menu \"~~~~~~~~~~\" \ncmd \" ~ 'Chooser' ~\" /usr/bin/defaults-chooser \nend \n cmd \" ~ ROX-Filer ~\" \"rox ~\"" >> "$DeFProgs"
}

ls -Algoh --file-type defau* | awk '$1 !~ /lrw/ && $7 !~ /.cdr/ && $7 !~ /.bak/ && $7 !~ /han/ && $7 !~ /NON/ { print $7 }' > /tmp/liste-progs

[ ! -f /tmp/compte-de-lignes ] || [ "`awk '{ print $1 }' /tmp/compte-de-lignes`" -ne "`wc -l /tmp/liste-progs | awk '{ print $1 }'`" ] && construire
# Si les décomptes de ligne ne concordent pas ou si le fichier de réf. n'existe pas,
# on reconstruit le menu. Si par contre tout est ok, l'affichage est immédiat.
# NOTA. Si vous changez quelque chose dans les "default-quelque-chose" dans
# /usr/local/bin et que le menu ne semble pas se rafraîchir, effacez le fichier
# /tmp/compte-de-lignes et relancez le script.

aemenu -rc "$DeFProgs"
# set +xe
